Bug 47994 - ScriptInterpreterSource apparently broken in Windows 7
Summary: ScriptInterpreterSource apparently broken in Windows 7
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: Runtime Config (show other bugs)
Version: 2.2.14
Hardware: PC Windows Vista
: P4 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2009-10-14 10:17 UTC by Terry Cassidy
Modified: 2018-11-07 21:08 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Terry Cassidy 2009-10-14 10:17:03 UTC
I have been using 'ScriptInterpreterSource Registry-strict' on my Windows XP system to override shebang without problem. Attempting to migrate to Windows 7 (skipping Vista) ScriptInterpreterSource seems to be broken and the reason appears to be that file association is handled totally differently in Windows 7; this apparently causes Apache to revert to shebang behaviour. I've verified this by putting a Windows shebang in a test file and it works properly. Here is the sum total of the registry entries for a .pl extension:

---
Windows Registry Editor Version 5.00

[HKEY_CLASSES_ROOT\.pl]
"PerceivedType"="text"
@="Perl"

[HKEY_CLASSES_ROOT\.pl\PersistentHandler]
@="{5e941d80-bf96-11cd-b579-08002b30bfeb}"
---

I've tried to back down to 'ScriptInterpreterSource Registry' but no luck.

I'm fairly certain my file associations are configured correctly. I'm able to invoke a perl script by clicking on it in Explorer and by typing the name only at the command prompt.

Is there any work-around aside from shebangin' all my scripts (that run on Linux as well)?
Comment 1 Terry Cassidy 2009-10-22 16:12:55 UTC
It turns out that 'ScriptInterpreterSource Registry' for a .pl extension
DOES work even though the description of the registry tree in the Apache
docs is incorrect for Windows 7. Getting other extensions to invoke Perl
apparently cannot be done with the tools available at the Windows
Control Panel but use of shell commands may be able to accomplish this.
I have not discovered ANY tools that can set up extension processing for
'ScriptInterpreterSource Registry-Strict' aside from direct hacking with
REGEDIT.

It looks like ScriptInterpreterSource is badly crippled by Windows 7
and perhaps an alternative (like other suggestions to directly specify the
script interpreter) should be considered.
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:09 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.